summaryrefslogtreecommitdiff
path: root/test/integration/framework
diff options
context:
space:
mode:
authorDavid Kalnischkies <david@kalnischkies.de>2016-04-07 17:48:17 +0200
committerDavid Kalnischkies <david@kalnischkies.de>2016-04-25 15:35:52 +0200
commit742f67eaede80d2f9b3631d8697ebd63b8f95427 (patch)
tree1331d0dc34b14005ce85c542cbf0631899cd6cfa /test/integration/framework
parent6d9b79dd961242702f0079e3dab2dd1c62bbc61e (diff)
don't ask server if we have entire file in partial/
We have this situation in cases were parts of the transaction are refused (e.g. in a hashsum mismatch) and rerun the update (e.g. in the hope that we get a mirror which is synced this time). Previously we would ask the server with an if-range and in the best case recieve a 416 in response (less featureful server might end up giving us the entire file again or we get the wrong file this time giving us a hashsum mismatch…), which is a waste of time if we know already by checking the hashsums that we got the complete and correct file.
Diffstat (limited to 'test/integration/framework')
-rw-r--r--test/integration/framework16
1 files changed, 12 insertions, 4 deletions
diff --git a/test/integration/framework b/test/integration/framework
index 213169a98..2a78e6194 100644
--- a/test/integration/framework
+++ b/test/integration/framework
@@ -1505,6 +1505,14 @@ testmarkedmanual() {
msggroup
}
+catfile() {
+ if [ "${1##*.}" = 'deb' ]; then
+ stat >&2 "$1" || true
+ file >&2 "$1" || true
+ else
+ cat >&2 "$1" || true
+ fi
+}
msgfailoutput() {
msgreportheader 'msgfailoutput'
local MSG="$1"
@@ -1514,7 +1522,7 @@ msgfailoutput() {
echo >&2
while [ -n "$2" ]; do shift; done
echo "#### Complete file: $1 ####"
- cat >&2 "$1" || true
+ catfile "$1"
echo '#### grep output ####'
elif [ "$1" = 'test' ]; then
echo >&2
@@ -1529,7 +1537,7 @@ msgfailoutput() {
ls >&2 "$2" || true
elif test -e "$2"; then
echo "#### Complete file: $2 ####"
- cat >&2 "$2" || true
+ catfile "$2"
fi
fi
}
@@ -1543,12 +1551,12 @@ msgfailoutput() {
echo >&2
while [ -n "$2" ]; do
echo "#### Complete file: $2 ####"
- cat >&2 "$2" || true
+ catfile "$2"
shift
done
echo '#### cmp output ####'
fi
- cat >&2 "$OUTPUT"
+ catfile "$OUTPUT"
msgfail "$MSG"
}